// This file is released into the public domain
//=================================
if ~isdef('glx_mat2div')  then
  root_tlbx_path = SCI+'\contrib\fact\';   
  exec(root_tlbx_path + 'loader.sce',-1); 
end
//=================================resume
 
 
  // -------------------------------------------------------
  // ATTENTION: CRASH AVEC SCILAB 6.0 (BUG AVEC savematfile)
  // -------------------------------------------------------
 
  sci_version=strtod(part(getversion(),[8 ;9 ;10]));
  
  // début d'une instruction if
  if sci_version < 6 then


 
  // -----------------------
  // exemple 1: régressions
   
  // obtention des données:
  load('x_pca_pls.dat')  // Cargill dataset
  x=div(x_pca_pls.x);
  y=div(x_pca_pls.y); 
  res=pls(x,y,5,20);
  
  res2=regapply(res,x,y);

  // application de div2mat: 
  matname='respls.mat';
  res3=div2mat(res,matname);
  
  // application de mat2div:
  res3bis=glx_mat2div(matname);
  
  res3ter=regapply(res3bis,x,y);
  
  
  // validation de la non-perte de données avec div2mat et mat2div:
  if max(abs(res2.r2.d-res3ter.r2.d))> 0.0000000001 then
      error('problem with mat2div or div2mat')
  end



  // ---------------------------------
  // exemple 2: PLSDA
  
  // obtention des données: 
  load x_140farines.dat

  x=xfarines;
    
 
  // modèle PLS-DA
  [model_plsda]=plsda(x,groupes,4,4);
  [model2_plsda_bis]=daapply(model_plsda,x,groupes);
  
  // applicaton de div2mat et glx_mat2div
  matname2='resplsda.mat';
  model3_plsda=div2mat(model_plsda,matname2);
  model3bis_plsda=glx_mat2div(matname2);
  model3ter_plsda=daapply(model3bis_plsda,x,groupes);
  
  // comparaison des résultats: direct / div2mat +glx_mat2div
  difference=model2_plsda_bis.err_test.d - model3ter_plsda.err_test.d;
  if max(abs(difference))>0.00001 then
      pause 
  end

 
  // ---------------------------------------------------------------
  // exemple 2: ACOM (choisi car les sorties comprennent des listes)
  loadmatfile x_acom1.mat
  x2=list();
  x2(1)=x.col1;
  x2(2)=x.col2;
  x2(3)=x.col3;
  x2(4)=x.col4;
  x2(5)=x.col5;
  
  res_acom=acom1(x2,8);

  matname3='resacom.mat';
  res4=div2mat(res_acom,matname3);
  res4bis=glx_mat2div(matname3);

  
  if  ~isdef('res3bis') | ~isdef('res4bis') then
      pause
  end
  
  deletefile('respls.mat');
  deletefile('resplsda.mat');
  deletefile('resacom.mat');
  
  
  // fin de l'instruction if du tout début (5.5 vs. 6.0)
  end  
  
  clear x x2 y res res2 res3 res3bis res3ter x_pca_pls res4 res4bis res_acom matname matname2 
  clear matname3 model3ter_plsda model3bis_plsda model2_plsda_bis model_plsda model groupes
  clear xfarines difference s1 s2 s3 s4 m1 m2 m3 m4 model2 groupes2 conf_cv conf_cal
  clear vp_cal err_cal_2 err_cv_2 conf_cv_2 conf_cal_2 vp_cal_2
  clear model3_plsda err_cal err_cv sci_version

 

  // ================================================================================
  
  
  
  
  
